import _classCallCheck from 'babel-runtime/helpers/classCallCheck';
import _possibleConstructorReturn from 'babel-runtime/helpers/possibleConstructorReturn';
import _inherits from 'babel-runtime/helpers/inherits';
import React from 'react';
import ReactDOM from 'react-dom';
import * as PropTypes from 'prop-types';

var Portal = function (_React$Component) {
  _inherits(Portal, _React$Component);

  function Portal() {
    _classCallCheck(this, Portal);

    return _possibleConstructorReturn(this, _React$Component.apply(this, arguments));
  }

  Portal.prototype.componentDidMount = function componentDidMount() {
    this.createContainer();
  };

  Portal.prototype.componentDidUpdate = function componentDidUpdate(prevProps) {
    var didUpdate = this.props.didUpdate;

    if (didUpdate) {
      didUpdate(prevProps);
    }
  };

  Portal.prototype.componentWillUnmount = function componentWillUnmount() {
    this.removeContainer();
  };

  Portal.prototype.createContainer = function createContainer() {
    this._container = this.props.getContainer();
    this.forceUpdate();
  };

  Portal.prototype.removeContainer = function removeContainer() {
    if (this._container) {
      this._container.parentNode.removeChild(this._container);
    }
  };

  Portal.prototype.render = function render() {
    if (this._container) {
      return ReactDOM.createPortal(this.props.children, this._container);
    }
    return null;
  };

  return Portal;
}(React.Component);

Portal.propTypes = {
  getContainer: PropTypes.func.isRequired,
  children: PropTypes.node.isRequired,
  didUpdate: PropTypes.func
};
export default Portal;